%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Lachaise Assignment
% LaTeX Template
% Version 1.0 (26/6/2018)
%
% This template originates from:
% http://www.LaTeXTemplates.com
%
% Authors:
% Marion Lachaise & François Févotte
% Vel (vel@LaTeXTemplates.com)
%
% License:
% CC BY-NC-SA 3.0 (http://creativecommons.org/licenses/by-nc-sa/3.0/)
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%----------------------------------------------------------------------------------------
%	PACKAGES AND OTHER DOCUMENT CONFIGURATIONS
%----------------------------------------------------------------------------------------

\newcommand{\length}[1]{|#1|}
\newcommand{\enc}[1]{\llbracket #1 \rrbracket }
\newtheorem{lemma}{Lemma}

\documentclass{article}

\input{structure.sty} % Include the file specifying the document structure and custom commands


%----------------------------------------------------------------------------------------
%	INFORMATION
%----------------------------------------------------------------------------------------

\title{Probabilistic Bisimulations} % Title of the assignment

\date{\today} % University, school and/or department name(s) and a date

%----------------------------------------------------------------------------------------

\begin{document}

\maketitle % Print the title

\section{Probabilistic Barbed Congruence}
$u$ is an action
\begin{definition}
	Let $\mathcal{R} \subseteq \mathcal{P} \times \mathcal{P}$ be a relation from processes to processes. We lift it to a relation $\mathcal{\overline{R}} \subseteq \mathcal{D}\left(\mathcal{P}\right) \times \mathcal{D}\left(\mathcal{P}\right)$ be letting $\Delta \mathcal{\overline{R}} \Theta$ whenever
	\begin{enumerate}
		\item $\Delta = \sum_{i \in I}p_i \cdot \overline{P_i}$, where $I$ is a finite index set and $\sum_{i \in I}p_i = 1$
		\item For each $i \in I$ there is a process $Q_i$ such that $P_i \mathcal{R} Q_i$
		\item $\Theta = \sum_{i \in I}p_i \cdot \overline{Q_i}$.
	\end{enumerate}
\end{definition}

We write $Q \xLongrightarrow{\hat{u}} \Theta$ for $Q \xLongrightarrow{u} \Theta$, if $u \neq \tau$.
\begin{definition}[Definition 3.3]
	An equivalence relation $\mathcal{R} \subseteq \mathcal{P} \times \mathcal{P}$ is a (weak) bisimulation if $P \mathcal{R} Q$ and $P \xlongrightarrow{u} \Delta$ implies $Q \xLongrightarrow{\hat{u}} \Theta$ such that $\Delta \mathcal{\overline{R}} \Theta$.
	
	Two processes $P$ and $Q$ are bisimilar, written $P \approx_w Q$, if there exists a bisimulation $\mathcal{R}$ s.t. $P \mathcal{R} Q$.
\end{definition}

\begin{definition}[Definition 3.8]
	Two processes $P$, $Q$ are observationally equivalent, written $P \simeq_w Q$, if
	\begin{enumerate}
		\item whenever $P \xlongrightarrow{u} \Delta$, there exists $\Theta$ s.t. $Q \xLongrightarrow{u} \Theta$ and $\Delta \overline{\approx_w} \Theta$
		\item whenever $Q \xlongrightarrow{u} \Theta$, there exists $\Delta$ s.t. $P \xLongrightarrow{u} \Delta$ and $\Delta \overline{\approx_w} \Theta$.
	\end{enumerate}
\end{definition}

\begin{definition}[Definition 4.1]
	An equivalence relation $\mathcal{R} \subseteq \mathcal{P} \times \mathcal{P}$ is a barbed bisimulation if $P \mathcal{R} Q$ implies:
	\begin{enumerate}
		\item whenever $P \xlongrightarrow{\tau} \Delta$ then $Q \xLongrightarrow{\hat{\tau}} \Theta$ and $\Delta \mathcal{\overline{R}} \Theta$
		\item for each atomic action $a$, if $P \downarrow_a$ then $Q \Downarrow_a$.
	\end{enumerate}
	Two processes $P$ and $Q$ are barbed-bisimilar, written $P \approx_b Q$, if $P \mathcal{R} Q$ for some barbed bisimulation $\mathcal{R}$.
\end{definition}
Diese aber barbed zu success
Und da pre-order 1. und 2. auch für die andere Richtung aufschrieben

\begin{definition}[Definition 4.3]
	Two processes $P$ and $Q$ are barbed-congruent, denoted by $P \simeq_b Q$, if for each context $C\left[\cdot\right]$, it holds that $C\left[P\right] \approx_b C\left[Q\right]$.
\end{definition}



\section{Bisimulation for Quantum Processes}
\begin{definition}[Definition 4.3]
	A relation $\mathcal{R} \subseteq Con \times Con$ is called a bisimulation if for any $\left<P, \rho\right>$, $\left<Q, \sigma\right> \in Con$, $\left<P, \rho\right> \mathcal{R} \left<Q, \sigma\right>$ implies that $qv\left(P\right) = qv\left(Q\right)$, $\text{tr}_{qv\left(P\right)}\left(\rho\right) = \text{tr}_{qv\left(Q\right)}\left(\sigma \right)$, and 
	\begin{enumerate}
		\item whenever $\left<P, \rho\right> \xlongrightarrow{c?q} \mu$ then $\left<Q, \sigma\right> \xLongrightarrow{}\xlongrightarrow{c?q} \nu$ for some $\nu$ such that for any super-operator $\epsilon$ acting on $\mathcal{H}$, $\epsilon\left(\mu\right)\mathcal{R}\epsilon\left(\nu\right)$;
		\item whenever $\left<P, \rho\right> \xlongrightarrow{\alpha} \mu$ where $\alpha$ is not a quantum input, then there exists $\nu$ such that $\left<Q, \sigma\right> \xLongrightarrow{\hat{\alpha}} \nu$ and $\mu \mathcal{R} \nu$;
		\item whenever $\left<Q, \sigma\right> \xlongrightarrow{c?q} \nu$, then $\left<P, \rho\right> \xLongrightarrow{}\xlongrightarrow{c?q} \mu$ for some $\mu$ such that for any super-operator $\epsilon$ acting on $\mathcal{H}$, $\epsilon\left(\mu\right)\mathcal{R}\epsilon\left(\nu\right)$;
		\item whenever $\left<Q, \sigma\right> \xlongrightarrow{\alpha} \nu$ where $\alpha$ is not a quantum input, then there exists $\mu$ such that $\left<P, \rho\right> \xLongrightarrow{\hat{\alpha}} \mu$ and $\mu\mathcal{R}\nu$.
	\end{enumerate}
\end{definition}
Here for any $s \in Act^*$, $\hat{s}$ is the string obtained from $s$ by deleting all the occurrences of $\tau$.



\section{Bisimulations for Probabilistic and Quantum Processes}
Let $s$ and $t$ be two states in a probabilistic LTS. We say $t$ can simulate the behaviour of $s$ if whenever the latter can exhibit some action, say $a$, and lead to distribution $\Delta$ then the former can also perform $a$ and lead to a distribution, say $\Theta$, which the in turn can mimic $\Delta$ in successor states.
\begin{definition}[Definition 6]
	A relation $\mathcal{R} \subseteq S \times S$ is a probabilistic simulation if $s \mathcal{R} t$ implies if $s \xlongrightarrow{a} \Delta$ then there exists some $\Theta$ such that $t \xlongrightarrow{a} \Theta$ and $\Delta \mathcal{R}^{\dagger} \Theta$.
	If both $\mathcal{R}$ and $\mathcal{R}^{-1}$ are probabilistic simulations, then $\mathcal{R}$ is a probabilistic bisimulation.
\end{definition}

\begin{definition}[Definition 8]
	Let $\sim_d \subseteq \mathcal{D}_{sub}\left(S\right) \times \mathcal{D}_{sub}\left(S\right)$ be the largest symmetric relation such that if $\Delta \sim_d \Theta$ then $\length{\Delta} = \length{\Theta}$ and $\Delta \xlongrightarrow{a} \Delta'$ implies the existence of some $\Theta'$ such that $\Theta \xlongrightarrow{a} \Theta'$ and $\Delta' \sim_d \Theta'$.
\end{definition}

We use the notation $qv\left(\mathcal{C}\right) := qv\left(P\right)$ for free quantum variables and $\text{env}\left(\mathcal{C}\right) := \text{tr}_{qv\left(P\right)}\left(\rho\right)$ for partial traces.

\begin{definition}
	$\alpha \quad ::= \quad  \tau \quad \mid \quad c?x \quad \mid \quad c!e \quad \mid \quad c?q \quad \mid \quad c!q \quad \mid \quad \epsilon\left[\tilde{q}\right] \quad \mid \quad M\left[\tilde{q}; x\right]$
\end{definition}

\begin{definition}[Definition 9]
	A symmetric relation $\mathcal{R} \subseteq Con \times Con$ is called an open bisimulation if for any $\mathcal{C}$, $\mathcal{D} \in Con$, $\mathcal{C} \mathcal{R} \mathcal{D}$ implies that
	\begin{enumerate}
		\item $qv\left(\mathcal{C}\right) = qv\left(\mathcal{D}\right)$, and $\text{env}\left(\mathcal{C}\right) = \text{env}\left(\mathcal{D}\right)$,
		\item for any trace-preserving super-operator $\epsilon$ acting on $\mathcal{H}$, whenever $\epsilon\left(\mathcal{C}\right) \xlongrightarrow{\alpha} \Delta$, there exists $\Theta$ such that $\epsilon\left(\mathcal{D}\right) \xlongrightarrow{\alpha} \Theta$ and $\Delta \mathcal{R}^{\dagger} \Theta$.
	\end{enumerate}
	Two quantum configurations $\mathcal{C}$ and $\mathcal{D}$ are open bisimilar, denoted by $\mathcal{C} \sim_o \mathcal{D}$, if there exists an open bisimulation $\mathcal{R}$ such that $\mathcal{C} \mathcal{R} \mathcal{D}$.
\end{definition}

\begin{definition}[Definition 12]
	A relation $\mathcal{R} \subseteq Con \times Con$ is called a ground simulation if $\mathcal{C} \mathcal{R} \mathcal{D}$ implies that $qv\left(\mathcal{C}\right) = qv\left(\mathcal{D}\right)$, $\text{env}\left(\mathcal{C}\right) = \text{env}\left(\mathcal{D}\right)$, and whenever $\mathcal{C} \xlongrightarrow{\alpha} \Delta$, there is some distribution $\Theta$ with $\mathcal{D} \xlongrightarrow{\alpha} \Theta$ and $\Delta \mathcal{R}^{\dagger} \Theta$. 
	
	A relation $\mathcal{R}$ is a ground bisimulation if both $\mathcal{R}$ and $\mathcal{R}^{-1}$ are ground simulations.
\end{definition}

\begin{definition}[Definition 14]
	A relation $\mathcal{R} \subseteq Con \times Con$ is a distribution-based ground simulation if $\Delta \mathcal{R} \Theta$ implies that $qv\left(\mathcal{C}\right) = qv\left(\mathcal{D}\right)$, $\text{env}\left(\mathcal{C}\right) = \text{env}\left(\mathcal{D}\right)$, and whenever $\Delta \xlongrightarrow{\alpha} \Delta'$ and $\Delta' \mathcal{R} \Theta'$. 
	
	A relation $\mathcal{R}$ is a distribution-based ground bisimulation if both $\mathcal{R}$ and $\mathcal{R}^{-1}$ are distribution-based ground simulations.

	A relation $\mathcal{R}$ is a distribution-based bisimulation if it is a distribution-based ground bisimulation, and is closed under super-operator applications.
\end{definition}



\section{Proof of Lemma 3.11}
\begin{definition}[Operational Correspondence]
	An encoding $\enc{\cdot}: \mathcal{P}_S \rightarrow \mathcal{P}_T$ is strongly operationally corresponding w.r.t. $\mathcal{R}_T \subseteq \mathcal{P}_T^2$ if it is:
	\begin{enumerate}
		\item Strongly Complete: $\forall S, S' . S \mapsto_S S'$ implies $\left(\exists T . \enc{S} \mapsto_T T \wedge \left(\enc{S'}, T\right) \in \mathcal{R}_T\right)$
		\item Strongly Sound: $\forall S, T . \enc{S} \mapsto_T T$ implies $\left(\exists S' . S \mapsto_S S' \wedge \left(\enc{S'}, T\right) \in \mathcal{R}_T\right)$
	\end{enumerate}
\end{definition}

\begin{definition}[Bisimulation]
	$\mathcal{R}$ is a bisimulation if for each $\left(P, Q\right) \in \mathcal{R}:$
	\begin{itemize}
		\item $P \mapsto P'$ implies $\exists Q' . Q \mapsto Q' \wedge \left(P', Q'\right) \in \mathcal{R}$
		\item $Q \mapsto Q'$ implies $\exists P' . P \mapsto P' \wedge \left(P', Q'\right) \in \mathcal{R}$
	\end{itemize}
\end{definition}

\begin{lemma}[Lemma 3.11]
	An encoding $\enc{\cdot}: \mathcal{P}_S \rightarrow \mathcal{P}_T$ is operational corresponding w.r.t a preorder $\mathcal{R}_T \subseteq \mathcal{P}_T^2$ that is a bisimulation iff $\exists \mathcal{R}_{\enc{\cdot}} . \left(\forall S . \left(S, \enc{S}\right) \in \mathcal{R}_{\enc{\cdot}}\right) \wedge \mathcal{R}_T = \mathcal{R}_{\enc{\cdot}}\upharpoonright _{\mathcal{P}_T} \wedge \left(\forall S, T . \left(S, T\right) \in \mathcal{R}_{\enc{\cdot}} \rightarrow \left(\enc{S}, T\right) \in \mathcal{R}_T\right) \wedge \mathcal{R}_{\enc{\cdot}}$ is a preorder and a bisimulation.
\end{lemma}
\begin{align*}
	&\text{Part }\Rightarrow\\
	&(\text{For }\enc{\cdot}: \mathcal{P}_S \rightarrow \mathcal{P}_T .\\
	&\quad\left(\forall S, S' . S \mapsto_S S' \Rightarrow \left(\exists T . \enc{S} \mapsto_T T \wedge \left(\enc{S'}, T\right) \in \mathcal{R}_T\right)\right) \wedge \\
	&\quad\left(\forall S, T . \enc{S} \mapsto_T T \Rightarrow \left(\exists S' . S \mapsto_S S' \wedge \left(\enc{S'}, T\right) \in \mathcal{R}_T\right)\right) \wedge \\
	&\quad(\forall \left(T_1, T_2\right) \in \mathcal{R}_T . \\
	&\quad\quad \left(T_1 \mapsto_T T_1' \Rightarrow \exists T_2' . T_2 \mapsto_T T_2' \wedge \left(T_1', T_2'\right) \in \mathcal{R_T}\right) \wedge\\
	&\quad\quad \left(T_2 \mapsto_T T_2' \Rightarrow \exists T_1' . T_1 \mapsto_T T_1' \wedge \left(T_1', T_2'\right) \in \mathcal{R}_T\right))\\
	&\quad\Rightarrow\\
	&\quad (\exists \mathcal{R}_{\enc{\cdot}} . \left(\forall S . \left(S, \enc{S}\right) \in \mathcal{R}_{\enc{\cdot}}\right) \wedge \mathcal{R}_T = \mathcal{R}_{\enc{\cdot}}\upharpoonright _{\mathcal{P}_T} \wedge \left(\forall S, T . \left(S, T\right) \in \mathcal{R}_{\enc{\cdot}} \rightarrow \left(\enc{S}, T\right) \in \mathcal{R}_T\right) \wedge\\
	&\quad\quad \mathcal{R}_{\enc{\cdot}}\upharpoonright _{\mathcal{P}_T} = \left\{\left( T, T^*\right) \mid T, T^* \in \mathcal{P}_T \wedge \left(T, T^* \right) \in \mathcal{R}_{\enc{\cdot}} \right\} \wedge\\
	&\quad\quad (\forall \left(S, T\right) \in \mathcal{R}_{\enc{\cdot}} . \\
	&\quad\quad\quad \left(S \mapsto_S S' \Rightarrow \exists T' . T \mapsto_T T' \wedge \left(S', T'\right) \in \mathcal{R}_{\enc{\cdot}}\right) \wedge\\
	&\quad\quad\quad \left(T \mapsto_T T' \Rightarrow \exists S' . S \mapsto_S S' \wedge \left(S', T'\right) \in \mathcal{R}_{\enc{\cdot}}\right)))
\end{align*}

For an operational corresponding $\enc{\cdot}: \mathcal{P}_S \rightarrow \mathcal{P}_T$ w.r.t. a preorder $\mathcal{R}_T \subseteq \mathcal{P}_T^2$ that is a bisimulation, assume there is a $S$ which can do a step $S \mapsto_S S'$.
This implies by completeness $\exists T . \enc{S} \mapsto_T T \wedge \left(\enc{S'}, T\right) \in \mathcal{R}_T$.
The steps $S \mapsto_S S'$ and $\enc{S} \mapsto_T T$ imply 
\begin{align*}
	&\text{Part }\Leftarrow\\
	&(\exists \mathcal{R}_{\enc{\cdot}} . \left(\forall S . \left(S, \enc{S}\right) \in \mathcal{R}_{\enc{\cdot}}\right) \wedge \mathcal{R}_T = \mathcal{R}_{\enc{\cdot}}\upharpoonright _{\mathcal{P}_T} \wedge \left(\forall S, T . \left(S, T\right) \in \mathcal{R}_{\enc{\cdot}} \rightarrow \left(\enc{S}, T\right) \in \mathcal{R}_T\right) \wedge\\
	&\quad \mathcal{R}_{\enc{\cdot}}\upharpoonright _{\mathcal{P}_T} = \left\{\left( T, T^*\right) \mid T, T^* \in \mathcal{P}_T \wedge \left(T, T^* \right) \in \mathcal{R}_{\enc{\cdot}} \right\})\wedge\\
	&\quad (\forall \left(S, T\right) \in \mathcal{R}_{\enc{\cdot}} . \\
	&\quad\quad \left(S \mapsto_S S' \Rightarrow \exists T' . T \mapsto_T T' \wedge \left(S', T'\right) \in \mathcal{R}_{\enc{\cdot}}\right) \wedge\\
	&\quad\quad \left(T \mapsto_T T' \Rightarrow \exists S' . S \mapsto_S S' \wedge \left(S', T'\right) \in \mathcal{R}_{\enc{\cdot}}\right)))\\
	&\quad\Rightarrow\\
	&\quad(\exists\enc{\cdot}: \mathcal{P}_S \rightarrow \mathcal{P}_T .\\
	&\quad\quad\left(\forall S, S' . S \mapsto_S S' \Rightarrow \left(\exists T . \enc{S} \mapsto_T T \wedge \left(\enc{S'}, T\right) \in \mathcal{R}_T\right)\right) \wedge \\
	&\quad\quad\left(\forall S, T . \enc{S} \mapsto_T T \Rightarrow \left(\exists S' . S \mapsto_S S' \wedge \left(\enc{S'}, T\right) \in \mathcal{R}_T\right)\right) \wedge \\
	&\quad\quad(\forall \left(T_1, T_2\right) \in \mathcal{R}_T . \\
	&\quad\quad\quad \left(T_1 \mapsto_T T_1' \Rightarrow \exists T_2' . T_2 \mapsto_T T_2' \wedge \left(T_1', T_2'\right) \in \mathcal{R_T}\right) \wedge\\
	&\quad\quad\quad \left(T_2 \mapsto_T T_2' \Rightarrow \exists T_1' . T_1 \mapsto_T T_1' \wedge \left(T_1', T_2'\right) \in \mathcal{R}_T\right))\\
\end{align*}

\bibliographystyle{unsrt}
\bibliography{lit}

\end{document}
